var dock_el=null;
var dock_entries=[];

function init_dock()
{
	dock_el=open_floater("dock");

	init_clock();

	if(is_safari()) init_logout();

	refresh_dock();
}

function refresh_dock()
{
	dock_entries.sort(function(a,b) { return(b.priority-a.priority) })

	while(dock_el.firstChild) dock_el.removeChild(dock_el.firstChild);

	for(var i=0;i<dock_entries.length;i++) dock_el.appendChild(dock_entries[i].element);
}

function add_dock_icon(icon,name,description,priority,click_handler)
{
	var icon_el=make_element({ tag: "div", noselect: true, children: [
		{ tag: "img", src: icon },
		{ tag: "div", children: [name] }
	]});

	if(click_handler) icon_el.className="dockicon";
	else icon_el.className="noclickicon";

	icon_el.setAttribute("title",description);

	if(click_handler) icon_el.onclick=function(e) { click_handler(e) }

	add_dock_element(icon_el,priority);

	return(icon_el);
}

function add_dock_element(element,priority)
{
	dock_entries.push({ element: element, priority: priority||0 });
	if(dock_el) refresh_dock();
}



function init_clock()
{
	var clock_el=make_element({ tag: "div", className: "clock", noselect: true, children: ["00:00"] });

	update_clock(clock_el);

	add_dock_element(clock_el,-1000000);

	setInterval(function() {
		update_clock(clock_el);
	},1000);
}

function update_clock(clock_el)
{
	var date=new Date;

	var hours=date.getHours().toString();
	var minutes=date.getMinutes().toString();
	var datestr=date.toDateString();

	if(hours.length==1) hours="0"+hours;
	if(minutes.length==1) minutes="0"+minutes;

	clock_el.firstChild.nodeValue=hours+":"+minutes;
	clock_el.setAttribute("title",datestr);
}

function init_logout()
{
	var icon_el=add_dock_icon(".desktop/Applications/Dock/logout.png",
	"Log out","Click to log out and save all settings.",-2000,function() {
		do_logout();
		document.getElementById("logo").firstChild.nodeValue="Logged out";
	});
}

register_application(init_dock);
