var filemanager_dir_context=[];
var filemanager_file_context=[];

function register_file_context_entry(title,icon,test_handler,select_handler,priority)
{
	filemanager_file_context.push({ title: title, icon: icon,
	test_handler: test_handler, select_handler: select_handler,
	priority: priority });

	filemanager_file_context.sort(function(a,b) { return(b.priority-a.priority) })
}

function register_directory_context_entry(title,icon,select_handler,priority)
{
	filemanager_dir_context.push({ title: title, icon: icon,
	select_handler: select_handler, priority: priority });

	filemanager_dir_context.sort(function(a,b) { return(b.priority-a.priority) })
}

function filemanager_context_handler(window_el,x,y)
{
	if(disable_contextmenu) return;

	var menu=[];
	var selected=window_el.selected;
	var files=[];

	for(var i=0;i<selected.length;i++) files.push(selected[i].file);

	if(window_el.selected.length)
	{
		menu.push({ title: "Selected files" });
		for(var i=0;i<filemanager_file_context.length;i++)
		{
			if(filemanager_file_context[i].test_handler(files,selected,window_el))
			menu.push({
			title: filemanager_file_context[i].title,
			icon: filemanager_file_context[i].icon,
			select_handler: function(handler) { return function() { handler(files,selected,window_el) } }(filemanager_file_context[i].select_handler)
			});
		}
	}

	menu.push({ title: "Directory" });
	for(var i=0;i<filemanager_dir_context.length;i++)
	{
		menu.push({
		title: filemanager_dir_context[i].title,
		icon: filemanager_dir_context[i].icon,
		select_handler: function(handler) { return function() { handler(window_el.directory,window_el) } }(filemanager_dir_context[i].select_handler)
		});
	}

	show_menu(menu,x,y);
}

function filemanager_init_context()
{
	register_file_context_entry("Rename",".desktop/Applications/Filemanager/rename.png",
	function(files,selected,window_el) { if(files.length==1) return(true); },
	function(files,selected,window_el) { filemanager_rename_file(window_el,selected[0]) },
	0);

	register_file_context_entry("Change permissions",".desktop/Applications/Filemanager/chmod.png",
	function(files,selected,window_el) { return(true); },
	function(files,selected,window_el) {
		var perm=files[0].permissions;
		for(var i=1;i<files.length;i++) if(files[i].permissions!=perm) { perm=""; break; }

		var title;
		if(files.length==1) title='"'+files[0].filename+'"';
		else title="these "+files.length+" files";

		var newperm;
		if(newperm=prompt("Change permissions for "+title+" to:",perm))
		{
			set_window_status(window_el,"Changing permissions...");
			chmod_files(files,newperm,function(success,failure) {
				if(failure.length) alert("The following files could not have their permissions changed:\n"+failure.join("\n"));
			});
		}
	},0);

	register_file_context_entry("Make copy",".desktop/Applications/Filemanager/copy.png",
	function(files,selected,window_el) { return(true); },
	function(files,selected,window_el) {
		copy_files(files,window_el.directory,function(success,failure) {
			filemanager_set_selection(window_el,success);

			if(failure.length)
			{
				alert("The following files could not be copied:\n"+failure.join("\n"));
			}
		});
	},0);

	register_file_context_entry("Run Javascript",".desktop/Applications/Filemanager/run_js.png",
	function(files,selected,window_el) { return(files.length==1&&files[0].type=="js"); },
	function(files,selected,window_el) {
		files[0].read_content(function(file,error) {
			if(error) set_window_status(window_el,"Couldn't load file: "+error);
			else
			{
				try { eval(file.content) }
				catch(e) { set_window_status(window_el,"Javascript error: "+e.message) }
			}
		});
	},0);

	register_file_context_entry("Delete",".desktop/Applications/Filemanager/delete.png",
	function(files,selected,window_el) { return(true); },
	function(files,selected,window_el) {
		filemanager_delete_files(files);
	},-1000);

	register_directory_context_entry("Create directory",".desktop/Applications/Filemanager/makedir.png",
	function(directory,window_el) {
		var dirname;
		if(dirname=prompt("Enter the name for the new directory:",""))
		{
			if(directory.files[dirname]) set_window_status(window_el,"That name already exists!");
			else
			{
				set_window_status(window_el,"Creating directory...");
				directory.makedir(dirname,function(newdir,error) {
					if(error) set_window_status(window_el,"Couldn't create the directory: "+error);
				});
			}
		}
	},0);

	register_directory_context_entry("Create file",".desktop/Applications/Filemanager/makefile.png",
	function(directory,window_el) {
		var filename;
		if(filename=prompt("Enter the name for the new file:",""))
		{
			if(directory.files[filename]) set_window_status(window_el,"That name already exists!");
			else
			{
				set_window_status(window_el,"Creating file...");

				var newfile=get_file(directory.fullpath+"/"+filename);
				newfile.content="";

				newfile.write_content(function(newfile,error) {
					if(error) set_window_status(window_el,"Couldn't create the file: "+error);
				});
			}
		}
	},0);
}
