use strict;

use File::Copy;

sub download_file($)
{
	my $query=shift;
	my $file=new fileobj($ENV{PATH_INFO});
	my $buf;

	if(!open FILE,$file->realpath()) # should use javascript
	{
		print "Status: 404 Not Found\n";
		print "Content-Type: text/html\n";
		print "\n";
		print "The file \"$file\" could not be found.";
		return;
	}

	print "Content-Type: application/octet-stream\n\n";
	binmode FILE;
	print $buf while(read(FILE,$buf,32768));
	close FILE;
}

sub upload_files($)
{
	my $query=shift;
	my $path=new fileobj($query->param("path"));
	my @params=$query->param();
	my (@success,@failure);

	my $res="";

	for(grep { /^file/ } @params)
	{
		my $file=$query->param($_);
		my $fh=$query->upload($_);
		next unless($file);

		my ($filename)=$file=~m!([^/\\]+)$!;
		my $newfile=new fileobj($path,$filename);

		if(copy($fh,$newfile->realpath())) { push @success,$newfile->get_data() }
		else { push @failure,js_string($filename); }
	}

	return_upload_result(success=>js_array(@success),failure=>js_array(@failure),path=>js_string($path->fullpath()));
}

sub return_upload_result(%)
{
	my %result=@_;
	print "Content-Type: text/html\n\n";
	print "<html><body><script type=\"text/javascript\">";
	print "parent.upload_done(".js_hash(%result).")";
	print "</script>";
	print "<h3>Files uploaded. Your browser does not fully support the uploading ";
	print "functionality, so you will have to click the \"Close\" button yourself.</h3>";
	print "</body></html>"
}

our %task_handlers;
$task_handlers{download}=\&download_file;
$task_handlers{upload}=\&upload_files;

1;
