var root_file;

function init_filesystem(root)
{
	root_file=new fileobj(root,null);
}

function get_file(path)
{
	var components=path.split(/\//);
	for(var i=0;i<components.length;i++) if(!components[i]) components.splice(i--,1);

	var file=root_file;

	for(var i=0;i<components.length;i++)
	{
		if(!file.files||!file.files[components[i]]) file.insert_details([{ filename: components[i] }]);
		file=file.files[components[i]];
	}

	return(file);
}



function fileobj(details,parent)
{
//	this.read_info=fileobj_read_info;
	this.read_content=fileobj_read_content;
	this.read_directory=fileobj_read_directory;
	this.write_content=fileobj_write_content;
	this.rename=fileobj_rename;
	this.delete_file=fileobj_delete;
	this.makedir=fileobj_makedir;
	this.sort_files=fileobj_sort_files;

	this.set_details=fileobj_set_details;
	this.unlist=fileobj_unlist;
	this.insert_details=fileobj_insert_details;
	this.replace_details=fileobj_replace_details;
	this.add_listener=fileobj_add_listener;
	this.remove_listener=fileobj_remove_listener;
	this.trigger_event=fileobj_trigger_event;

	this.toString=fileobj_tostring;

	this.listeners=[];

	this.set_details(details,parent);
}

function fileobj_read_directory(handler)
{
	var file=this;
	server_request("desktop.pl",
		{ task: "dirlist", path: file },
		function(result) {
			var response=eval(result);

			if(response.files) file.replace_details(response.files);

			//file.trigger_event(); // this really shouldn't trigger, right? right?
			handler(file,response.error);
		}
	);
}

function fileobj_read_content(handler)
{
	var file=this;
	server_request("desktop.pl",
		{ task: "readfile", file: file, charset: this.charset },
		function(result) {
			var response=eval(result);

			file.content=response.content;
			file.charset=response.charset;
			//file.set_details(response); // would this be better?

			handler(file,response.error);
		}
	);
}

function fileobj_write_content(handler)
{
	var file=this;
	server_request("desktop.pl",
		{ task: "writefile", file: file, content: file.content, charset: file.charset },
		function(result) {
			var response=eval(result);

			if(response.newfile)
			{
				file.set_details(response.newfile);
				file.parent.trigger_event();
			}
			handler(file,response.error);
		}
	);
}

function fileobj_rename(newname,handler)
{
	var file=this;
	var path=file.toString().match(/^(.*\/)/)[1];

	server_request("desktop.pl",
		{ task: "rename", file: file, newname: newname },
		function(result) {
			var response=eval(result);

			if(response.newfile)
			{
				file.set_details(response.newfile);
				file.parent.trigger_event();
			}
			handler(file,response.error);
		}
	);
}

function fileobj_delete(handler)
{
	var file=this;
	server_request("desktop.pl",
		{ task: "delete", file: file },
		function(result) {
			var response=eval(result);

			file.unlist();

			file.parent.trigger_event();
			handler(response.errors?response.errors[0]:undefined);
		}
	);
}

function fileobj_makedir(dirname,handler)
{
	var file=this;
	server_request("desktop.pl",
		{ task: "makedir", path: file.fullpath+"/"+dirname },
		function(result) {
			var response=eval(result);

			if(response.newfile)
			{
				file.insert_details([response.newfile]);
				file.trigger_event();
				handler(file.parent.files[dirname],response.error);
			}
			else handler(null,response.error);
		}
	);
}



function fileobj_sort_files(order)
{
	if(order=="alpha") this.files.sort(function(a,b) {
		if(a.dir&&!b.dir) return(-1);
		else if(!a.dir&&b.dir) return(1);
		else if(a.filename<b.filename) return(-1);
		else if(a.filename>b.filename) return(1);
		else return(0);
	});
}



function fileobj_set_details(details,parent)
{
	if(parent) this.parent=parent;

	if(this.filename!=details.filename && this.parent)
	{
		delete this.parent.files[this.filename];
		this.parent.files[details.filename]=this;
	}

	this.dir=this.link=this.deleted=false; // hmm, ugly.
	for(key in details) this[key]=details[key];

	if(this.parent) this.fullpath=this.parent.fullpath+"/"+this.filename;
	else this.fullpath="";

	if(this.dir) this.type=".directory";
	else this.type=this.filename.match(/([^\/\.]*)$/)[1].toLowerCase();

	this.icon_small=find_icon(this.type,"Small");
	this.icon_large=find_icon(this.type,"Large");
}

function fileobj_unlist()
{
	remove_list_entry(this.parent.files,this);
	delete this.parent.files[this.filename];

	if(this.files) while(this.files.length) this.files[0].unlist();

	this.deleted=true;
	this.trigger_event();
}

function fileobj_insert_details(files)
{
	if(!this.files) this.files=[];

	for(var i=0;i<files.length;i++)
	{
		var oldfile=this.files[files[i].filename];

		if(oldfile)
		{
			oldfile.set_details(files[i]);
			delete oldfile.deletionmark; // for replace_details
		}
		else
		{
			var newfile=new fileobj(files[i],this);
			this.files.push(newfile);
			this.files[newfile.filename]=newfile;
		}
	}
}

function fileobj_replace_details(files)
{
	if(!this.files) this.files=[];

	for(var i=0;i<this.files.length;i++) this.files[i].deletionmark=true;
	this.insert_details(files);
	for(var i=0;i<this.files.length;i++) if(this.files[i].deletionmark) this.files.splice(i--,1);
}

function fileobj_add_listener(handler)
{
	if(!in_list(this.listeners)) this.listeners.push(handler);
	return(handler);
}

function fileobj_remove_listener(handler)
{
	remove_list_entry(this.listeners,handler);
}

function fileobj_trigger_event()
{
	for(var i=0;i<this.listeners.length;i++) this.listeners[i](this);
}

function fileobj_tostring()
{
	return(this.fullpath);
}





function copy_files(files,path,handler)
{
	server_request("desktop.pl",
		{ task: "copy", file: files, path: path },
		function(result) {
			var response=eval(result);

			path.insert_details(response.success);

			path.trigger_event();
			handler(response.success,response.failure,response.errors);
		}
	);
}

function move_files(files,path,handler)
{
	server_request("desktop.pl",
		{ task: "move", file: files, path: path },
		function(result) {
			var response=eval(result);

			path.insert_details(response.success);
			path.trigger_event();

			unlist_and_trigger(files,response.failure);

			handler(response.success,response.failure,response.errors);
		}
	);
}

function delete_files(files,handler)
{
	server_request("desktop.pl",
		{ task: "delete", file: files },
		function(result) {
			var response=eval(result);

			unlist_and_trigger(files,response.failure);

			handler(response.failure,response.errors);
		}
	);
}

function chmod_files(files,permissions,handler)
{
	var path=files[0].parent; // this sucks!
	server_request("desktop.pl",
		{ task: "chmod", file: files, permissions: permissions },
		function(result) {
			var response=eval(result);

			path.insert_details(response.success);

			path.trigger_event();
			handler(response.success,response.failure,response.errors);
		}
	);
}

function unlist_and_trigger(files,failure)
{
		var sources={};
		for(var i=0;i<failure.length;i++) failure[failure[i]]=true;
		for(var i=0;i<files.length;i++) if(!failure[files[i].fullpath])
		{
			files[i].unlist();
			sources[files[i].parent.fullpath]=files[i].parent;
		}
		for(key in sources) sources[key].trigger_event();
}



function server_request(target,args,handler,sync)
{
	if(!args.auth) args.auth=desktop_auth;

	var contents=[];
	for(key in args)
	{
		var value=args[key];

		if(typeof value=="object"&&value.length)
		{
			for(var i=0;i<value.length;i++)
			if(value[i]||value[i]==0) contents.push(encodeURIComponent(key)+"="+encodeURIComponent(value[i]));
		}
		else if(value||value==0) contents.push(encodeURIComponent(key)+"="+encodeURIComponent(value));
	}

	var xmlhttp=get_xmlhttp();
	xmlhttp.open("POST",target,!sync);
	xmlhttp.onreadystatechange=function() {
		if(xmlhttp.readyState==4) handler(xmlhttp.responseText);
	}
	if(is_ie()||xmlhttp.setRequestHeader) xmlhttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
	xmlhttp.send(contents.join("&"));

	if(sync) handler(xmlhttp.responseText);
}
