use strict;

our %registry;
our %config;

sub check_auth($)
{
	my $auth=shift;
	my $challenge=get_challenge();

	my $correct=encode_base64(rc4("."x24,"$challenge:$config{user}:$config{passwd}"),"");

	if($auth eq $correct)
	{
		load_registry(".desktop/Config/registry.pl");
		return 1;
	}

	return 0;
}

sub get_challenge()
{
	return $ENV{REMOTE_ADDR};
}

sub get_login_data()
{
	return js_hash(
		challenge=>js_string(get_challenge())
	);
}

sub handle_login($)
{
	my $query=shift;
	my $auth=$query->param("auth");

	if(!check_auth($auth))
	{
		return_result(error=>js_string("Authentication failure"));
	}
	else
	{
		return_result(
			registry=>js_hash(%registry),
			root=>new fileobj("/")->get_data(),
		);
	}
}

our %noauth_handlers;
$noauth_handlers{login}=\&handle_login;

1;
