use strict;

use Data::Dumper;

our %registry;
my $registry_name;

sub sync_registry($)
{
	my $query=shift;
	my @entries=$query->param("entry");
	my @deletions=$query->param("delete");

	for(@entries)
	{
		next if($_ eq "");

		/^(('|")(?:.*?[^\\]|)(?:\\\\)*\2):(.*)$/; #"
		my $key=eval $1;
		my $value=$3;

		$registry{$key}=$value;
	}

	for(@deletions)
	{
		next if($_ eq "");

		delete $registry{$_};
	}

	unless(save_registry(%registry))
	{
		return_result(error=>js_string($!))
	}
	else
	{
		return_result();
	}
}

sub load_registry($)
{
	$registry_name=shift;

	my $contents;
	open FILE,$registry_name or return ();
	$contents.=$_ while(<FILE>);
	close FILE;

	my $registry=eval $contents;
	%registry=%$registry if(ref $registry eq "HASH");
}

sub save_registry()
{
	$Data::Dumper::Terse=1;
	$Data::Dumper::Indent=0;

	open FILE,">$registry_name" or return 0;
	print FILE Dumper(\%registry) or return 0;
	close FILE;

	return 1;
}

our %task_handlers;
$task_handlers{syncreg}=\&sync_registry;

1;
