use strict;

our %config;

sub show_config($)
{
	my $query=shift;

	print "Content-Type: ".get_xhtml_content_type("utf-8",1)."\n";
	print "\n";

	print compile_template(q{
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>Configure the desktop</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
</head>
<style type="text/css">
h1 { font-family: sans-serif; font-size: 1.2em; }
td { vertical-align: top }
</style>
<body>

<form action="desktop.pl" method="post">
<input type="hidden" name="task" value="setconf" />

<h1>Configure the desktop</h1>

<table><tbody>

<tr>
<td>Change user name:<br />
<small>(Leave empty to keep the old value.)</small></td>
<td><input type="text" name="new_user" /></td>
</tr>

<tr>
<td>Change password:<br />
<small>(Leave empty to keep the old value.)</small></td>
<td><input type="password" name="new_passwd" /></td>
</tr>

<tr>
<td>Retype password:</td>
<td><input type="password" name="check_passwd" /></td>
</tr>

<tr>
<td>Base directory:<br />
<small>(Leave empty to use the<br />
same directory that the script<br />
resides in.)</small></td>
<td><input type="text" name="base_path" value="<var $base_path>" /></td>
</tr>

<tr>
<td>Filesystem charset:<br />
<small>(Usually "utf8".)</small></td>
<td><input type="text" name="fs_charset" value="<var $fs_charset or "utf8">" /></td>
</tr>

<if $login>
<tr><td>&nbsp;</td><td></td></tr>

<tr>
<td>Old user name:</td>
<td><input type="password" name="old_user" /></td>
</tr>
<tr>
<td>Old password:</td>
<td><input type="password" name="old_passwd" /></td>
</tr>
</if>

<tr>
<td></td>
<td><input type="submit" value="Save settings" /></td>
</tr>


</tbody></table>

</form>

</body>
</html>
})->(%config,login=>%config?1:0);
}

sub set_config($)
{
	my $query=shift;
	my $user=$query->param("old_user");
	my $passwd=$query->param("old_passwd");
	my $new_user=($query->param("new_user"));
	my $new_passwd=($query->param("new_passwd"));
	my $check_passwd=$query->param("check_passwd");

	if(%config)
	{
		error("Wrong user name or password") if($user ne $config{user} or $passwd ne $config{passwd});
	}

	error("Passwords do not match") if($new_passwd and $new_passwd ne $check_passwd);

	$config{user}=$query->param("new_user") if($query->param("new_user"));
	$config{passwd}=$query->param("new_passwd") if($query->param("new_passwd"));

	$config{fs_charset}=$query->param("fs_charset");
	$config{base_path}=$query->param("base_path");

	save_config();

	make_http_forward($ENV{SCRIPT_NAME});
}

sub error($)
{
	print "Content-Type: ".get_xhtml_content_type("utf-8",1)."\n";
	print "\n";

	print compile_template(q{
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>Configure the desktop</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
</head>
<style type="text/css">
h1 { font-family: sans-serif; font-size: 1.2em; }
td { vertical-align: top }
</style>
<body>
<h1><var $error></h1>
</body>
</html>
})->(error=>shift);
	exit;
}

sub load_config()
{
	my $filename=".desktop/Config/server.pl";

	my $contents;
	open FILE,$filename or return ();
	$contents.=$_ while(<FILE>);
	close FILE;

	my $config=eval $contents;
	%config=%{$config} if(ref $config eq "HASH");
}

sub save_config()
{
	my $filename=".desktop/Config/server.pl";

	$Data::Dumper::Terse=1;
#	$Data::Dumper::Indent=0;

	open FILE,">$filename" or return 0;
	print FILE Dumper(\%config) or return 0;
	close FILE;

	return 1;
}

load_config();

our %noauth_handlers;
$noauth_handlers{config}=\&show_config;
$noauth_handlers{setconf}=\&set_config;

1;
